// import Vue from "vue";
import withRender from "./index.vtpl";
import "./index.less";


export default withRender({
	name: 'Tabs',
	props: {
		tabsContents: {
			type: Array,
			default: function () {
				return [];
			}
		},
		value: {
			type: Number,
			default: 0,
		},
		tabsCls: {
			type: String,
			default: ''
		},
		onChangeTabs: {
			type: Function,
			default: function () {

			}
		}
	},
	data() {
		return {
			activeIndex: this.value,
		};
	},
	watch: {
		'value'(val) {
			if (val !== this.activeIndex) {
				this.activeIndex = val;
			}
		}
	},
	methods: {
		changeTabs(item, index) {
			this.activeIndex = index;
			this.$emit('input', index);
			this.onChangeTabs(item, index);
		}
	},
});
